
/********************************************************/
/*							*/
/*		GRAF Demonstration Program		*/
/*							*/
/*	Uses the following .GRF files:			*/
/*	   TITLE, SMALL, MEDIUM, HUGH, BAR1		*/
/*	   BAR2, CIRCLE, LINE, and STAR			*/
/*							*/
/*   Don Brittain		    3 January 1983	*/
/*   4200 Spruce St. #208 	      phone:		*/
/*   Philadelphia, PA 19104	   (215) 386-2684	*/
/*							*/
/********************************************************/

#define HSIZE 400
#define VSIZE 408
#define LIST 5
#define ESC 27

char grafbuf[HSIZE][VSIZE/8];
int horsize, versize;
int flag=1;
char grafname[13];

#include "libc.h"

main()

{
    bdos(LIST,12);
    crlf(8);
    graph("title");
    crlf(3);
    margin(18);
    pr("Pro Writer PRELIMINARY VERSION 1.0");
       crlf(1);
    margin(23);
    pr("    3 January 1983");
    crlf(19);
    margin(27);
    pr("Don Brittain");
       crlf(1);
    margin(23);
    pr("4200 Spruce St. #208");
       crlf(1);
    margin(22);
    pr("Philadelphia, PA  19104");
       crlf(1);
    margin(26);
    pr("(215) 386-2684");
    crlf(12);
    pr("This program was written to illustrate the power of GRAF.  All");
       crlf(1);
    pr("the examples were created with this preliminary version.");
       crlf(2);
    pr("Actually, GRAF is just an interactive 'shell' allowing (minimal) ");
       crlf(1);
    pr("access to the modules grafutil.c, grafplot.c, grafline.c, graf-");
       crlf(1);
    pr("circ.c, grafinvt.c, and graffile.c.  These modules were originally");
       crlf(1);
    pr("written to be included in C programs requiring graphics.  GRAF");
       crlf(1);
    pr("hardly begins to utilize the real power of these subroutines.");
       crlf(1);
    pr("With them, C programs can easily be written to plot functions,");
       crlf(1);
    pr("draw recursive figures, plot solutions of ordinary differential");
       crlf(1);
    pr("equations, etc.  For technical details regarding the graphics");
       crlf(1);
    pr("modules (and a discussion of their shortcomings) see the file");
       crlf(1);
    pr("GRAF.DOC.");
       crlf(2);
    pr("I would appreciate being informed of any applications using these");
       crlf(1);
    pr("graphics subroutines.  Suggestions, criticisms, and improvements");
       crlf(1);
    pr("regarding any of my programs are always welcome.  I would also ");
       crlf(1);
    pr("like to know about other ProWriter graphics programs in the public");
       crlf(1);
    pr("domain.  I am particularly interested in 3-D graphics.  (This");
       crlf(1);
    pr("version of GRAF is FAR from supporting 3-D images!)");
       crlf(2);
    pr("Now for the demonstration:");
    crlf(10);
    pr("GRAF can create small graphs (as small as  1 x 1  pixels!):");
    graph("small");
    pr("Medium-size graphs:");
    graph("medium");
    crlf(5);
    pr("And huge graphs (as large as  400 x 400  pixels):");
    graph("hugh");
    pr("GRAF makes bar graphs easily:");
    graph("bar1");
    pr("and can 'invert' graphs with a single command:");
    graph("bar2");
    crlf(8);
    pr("GRAF also has a circle (ellipse?) plotting command:");
    crlf(2);
    graph("circle");
    crlf(3);
    pr("and the ability to plot (or unplot) points and lines:");
    crlf(3);
    graph("line");
    crlf(17);
    pr("In order to use GRAF, simply type 'graf' after CP/M signs on,");
       crlf(1);
    pr("enter the dimensions of the graph when asked, then (following the");
       crlf(1);
    pr("'command:' prompt) type HELP.  A list of GRAF commands, together");
       crlf(1);
    pr("with a brief description of their actions, will be displayed on");
       crlf(1);
    pr("your console. .........................................  Have fun!");
    crlf(5);
    graph("star");
    crlf(35);
}
    
    
graph(name)

char *name;

{
    FILE *fopen(), *fp;
    int vrt;
    register i,j;

    graffcb(name);
    fp=fopen(grafname,"r");
    if(fp==NULL) 	{
	printf("\nERROR: %s does not exist on ",grafname);
	printf("the current drive.\n\n");
	return();	}
    horsize=getw(fp);
    versize=getw(fp);
    vrt=(versize+7)/8;
    printf("\nThe graph in %s has the following dimensions:",grafname);
    printf("\n\tHorizontal size: %3d",horsize);
    printf("\n\tVertical size: %3d\n\n",versize);
    for(j=0; j<vrt; j++)
	for(i=0; i<horsize; i++)
	    grafbuf[i][j]=getc(fp);
    fclose(fp);
    grafprnt();
}

graffcb(name)

char *name;

{
    register i;

    for(i=0; (grafname[i]=toupper(name[i]))!='\0'; i++);
    grafname[i++]='.';
    grafname[i++]='G';
    grafname[i++]='R';
    grafname[i++]='F';
    grafname[i]='\0';
}

pr(name)

char *name;

{
    register i;
    
    margin(5);
    for(i=0; name[i]!='\0'; i++)
	bdos(LIST,name[i]);
}
	
	
grafprnt()

{
    register i, j;
    int v,w;
    
    v=(versize+7)/8;
    w=50-horsize/8;
    crlf(3);
    setline(8);
    bdos(LIST,ESC);
    bdos(LIST,'>');
    clmar(w);
    for(j=0; j<v; j++)	{
	bitmode(horsize);
	for(i=0; i<horsize; i++)
	    bdos(LIST, flip(grafbuf[i][j]));
	clmar(w);	}
    bdos(LIST,ESC);
    bdos(LIST,'<');
    crlf(3);
    setline(12);
}


setline(n)	/* routine to set the line-spacing on the Prowriter */
int n;
{
	int n1,n2;
	n = n*2;
	n1 = n/10 + 48;
	n2 = n%10 + 48;
    bdos(LIST,ESC);
    bdos(LIST,'T');
    bdos(LIST,n1);
    bdos(LIST,n2);
}

bitmode(n)	/* sets n chars of dot graphics on the Prowriter */
int n;
{
	int n1,n2,n3;
	n1 = n/100 + 48;
	n2 = (n%100)/10 +48;
	n3 = n%10 +48;
    bdos(LIST,ESC);
    bdos(LIST,'S');
    bdos(LIST,48);
    bdos(LIST,n1);
    bdos(LIST,n2);
    bdos(LIST,n3);
}


crlf(n)		/* printer carriage-return-linefeed */
int n;
{
int i;
for(i=0; i<n; i++)
    {
    bdos(LIST,13);
    bdos(LIST,10);
    }
}


margin(n)	/* printer left-margin */
int n;
{
int i;
for(i=0; i<n; i++)
    bdos(LIST,' ');
}

clmar(n)
int n;
{
crlf(1);
margin(n);
}

/* This assembly language routine inverts a byte so that it is    */
/* formatted correctly for the Pro Writer print head. More info   */
/* on this routine in the file GRAFUTIL.C     DmC 16 January 1984 */   

#asm
	public	flip_
flip_:	lxi	h,2
	dad	sp
	mov	a,m
	lxi	h,0
	mvi	d,0
	mvi	e,9h
agn:	dcr	e
	jz	back
	ral
inner:	mov	d,a
	mov	a,l
	rar
	mov	l,a
	mov	a,d
	jmp	agn
back:	mov	a,l
	ora	a
	ret
#endasm
