10 PRINT CHR$(26)
20 PRINT "THIS PROGRAM DESIGNS BUTTERWORTH LOWPASS AND HIGHPASS FILTERS"
30 PRINT
40 PRINT "For page, figure, and table references, see 'Simplified"
50 PRINT "Modern Filter Design' by Geffe"
60 PRINT
70 PI=3.14159
80 INPUT "Design low-pass or hi-pass filter (LO/HI)";T$
90 INPUT "Characteristic impedance ";Z
100 IF T$="hi" OR T$="HI" THEN GOTO 190
110 IF T$<>"lo" AND T$<>"LO" THEN PRINT "Try again!":PRINT:GOTO 80
120 PRINT:INPUT "Enter wp: highest passband frequency of interest, in Hz ",WP
130 PRINT:PRINT "Enter ap: max. attenuation, in dB, at highest"
140 INPUT "frequency of interest in passband ",AP
150 PRINT:INPUT "Enter ws: lowest stopband frequency of interest, in Hz ",WS
160 PRINT:PRINT "Enter as: min. attenuation, in dB, at lowest frequency"
170 INPUT "of interest in stopband ",AS
180 GOTO 250
190 PRINT:INPUT "Enter highest stopband frequency of interest, in Hz ",WP
200 PRINT:PRINT "Enter min. attenuation, in dB, at highest frequency of "
210 INPUT "interest in stopband ",AS
220 PRINT:INPUT "Enter lowest passband frequency of interest, in Hz ",WS
230 PRINT:PRINT "Enter max. attenuation, in dB, at lowest frequency of "
240 INPUT "interest in passband ",AP
250 WP=2*PI*WP
260 WS=2*PI*WS
270 Y=WS/WP
280 REM From fig. 1-6 (p. 8), determine min. number of poles
290 REM (n) which will yield desired min. attenuation in stopband at a
300 REM value of 'w' (= w's) approximately equal to y
310 GOSUB 980
320 REM From table 1-1 (p. 7), determine w (=w'p), by linear
330 REM interpolation if necessary, which provides attenuation in
340 REM passband which is equal to or greater than 'ap' for value of 'n'
350 GOSUB 1440
360 GOSUB 1510
370 X=FS/FP
380 IF X<=Y THEN 420 
390 ON N GOSUB 2000,1270,1290,1310,1330,1350,1370,1390,1410	'2000 is dummy
400 N=N+1
410 GOTO 360
420 PRINT:PRINT "n = ";N
430 WC=WP/FP
440 F3=WC/(2*PI)
450 PRINT "3-dB frequency = ";F3;" Hz"
460 REM L and C are scaled to L' and C' per page 5
470 LM=Z/WC
480 CM=1/(Z*WC)
490 REM array v(m,i) is table A2-1 (p. 117)
500 RESTORE 1780
510 FOR M=2 TO 10
520 FOR I=1 TO 10
530 READ V(M,I)
540 NEXT I
550 NEXT M
560 M=N
570 PRINT 
580 IF T$="lo" OR T$="LO" THEN PRINT"FOR SHUNT CAPACITOR INPUT" ELSE PRINT"FOR SHUNT INDUCTOR INPUT"
590 FOR I=1 TO 9 STEP 2
600 IF V(M,I)>0 THEN 610 ELSE 670
610 CV=V(M,I)*CM*10^6
620 IF T$="hi" OR T$="HI" THEN 650
630 GOSUB 1620
640 GOTO 670
650 LV=LM*10^3/V(M,I)
660 GOSUB 1680
670 NEXT I
680 FOR I=2 TO 10 STEP 2
690 IF V(M,I)>0 THEN 700 ELSE 760
700 LV=V(M,I)*LM*10^3
710 IF T$="hi" OR T$="HI" THEN 740
720 GOSUB 1680
730 GOTO 760
740 CV=CM*10^6/V(M,I)
750 GOSUB 1620
760 NEXT I
770 PRINT 
780 IF T$="lo" OR T$="LO" THEN PRINT"FOR SERIES INDUCTOR INPUT" ELSE PRINT"FOR SERIES CAPACITOR INPUT"
790 FOR I=1 TO 9 STEP 2
800 IF V(M,I)>0 THEN 810 ELSE 870
810 LV=V(M,I)*LM*10^3
820 IF T$="hi" OR T$="HI" THEN 850
830 GOSUB 1680
840 GOTO 870
850 CV=CM*10^6/V(M,I)
860 GOSUB 1620
870 NEXT I
880 FOR I=2 TO 10 STEP 2
890 IF V(M,I)>0 THEN 900 ELSE 960
900 CV=V(M,I)*CM*10^6
910 IF T$="hi" OR T$="HI" THEN 940
920 GOSUB 1620
930 GOTO 960
940 LV=LM*10^3/V(M,I)
950 GOSUB 1680
960 NEXT I
970 END
980 W2=10^(.025*AS)
990 W3=10^(.0169*(AS-1))
1000 W4=10^(.0127*(AS-1))
1010 W5=10^(.0103*(AS-2))
1020 W6=10^(.0089*(AS-3))
1030 W7=10^(.0075*(AS-3))
1040 W8=10^(.0065*(AS-3))
1050 W9=10^(.0058*(AS-3))
1060 W10=10^(.0053*(AS-3))
1070 IF Y>.6*W2 AND Y<1.4*W2 THEN N=2 ELSE 1090
1080 GOTO 1250
1090 IF Y>.6*W3 AND Y<1.4*W3 THEN N=3 ELSE 1110
1100 GOTO 1270
1110 IF Y>.6*W4 AND Y<1.4*W4 THEN N=4 ELSE 1130
1120 GOTO 1290
1130 IF Y>.6*W5 AND Y<1.4*W5 THEN N=5 ELSE 1150
1140 GOTO 1310
1150 IF Y>.6*W6 AND Y<1.4*W6 THEN N=6 ELSE 1170
1160 GOTO 1330
1170 IF Y>.6*W7 AND Y<1.4*W7 THEN N=7 ELSE 1190
1180 GOTO 1350
1190 IF Y>.6*W8 AND Y<1.4*W8 THEN N=8 ELSE 1210
1200 GOTO 1370
1210 IF Y>.6*W9 AND Y<1.4*W9 THEN N=9 ELSE 1230
1220 GOTO 1390
1230 IF Y>.6*W10 AND Y<1.4*W10 THEN N=10
1240 GOTO 1410
1250 FS=W2
1260 RETURN
1270 FS=W3
1280 RETURN
1290 FS=W4
1300 RETURN
1310 FS=W5
1320 RETURN
1330 FS=W6
1340 RETURN
1350 FS=W7
1360 RETURN
1370 FS=W8
1380 RETURN
1390 FS=W9
1400 RETURN
1410 FS=W10
1420 RETURN
1430 REM array a(p,w) is table 1-1 (p. 7)
1440 RESTORE 1870
1450 FOR P=2 TO 10
1460 FOR W=7 TO 9 
1470 READ A(P,W)
1480 NEXT W
1490 NEXT P
1500 RETURN
1510 P=N
1520 W=7
1530 IF A(P,W)=>AP THEN 1570
1540 W=8
1550 IF A(P,W)=>AP THEN 1570
1560 W=9
1570 E=A(P,W)
1580 W=W-1
1590 D=A(P,W)
1600 FP=(W+((AP-D)/(E-D)))/10
1610 RETURN
1620 IF CV<.001 THEN 1650
1630 PRINT "  C";I;" = ";CV;" uF"
1640 GOTO 1670
1650 CV=CV*10^6
1660 PRINT "  C";I;" = ";CV;" pF"
1670 RETURN
1680 IF LV=>.001 AND LV<.999999 THEN 1720
1690 IF LV<.001 THEN 1750
1700 PRINT "  L";I;" = ";LV;" mH"
1710 GOTO 1770
1720 LV=LV*1000
1730 PRINT "  L";I;" = ";LV;" uH"
1740 GOTO 1770
1750 LV=LV*10^6
1760 PRINT "  L";I;" = ";LV;" nH"
1770 RETURN
1780 DATA 1.414,1.414,0,0,0,0,0,0,0,0
1790 DATA 1,2,1,0,0,0,0,0,0,0
1800 DATA .7654,1.848,1.848,.7654,0,0,0,0,0,0
1810 DATA .618,1.618,2,1.618,.618,0,0,0,0,0
1820 DATA .5176,1.414,1.932,1.932,1.414,.5176,0,0,0,0
1830 DATA .445,1.247,1.802,2,1.802,1.247,.445,0,0,0
1840 DATA .3902,1.111,1.663,1.962,1.962,1.663,1.111,.3902,0,0
1850 DATA .3473,1,1.532,1.879,2,1.879,1.532,1,.3473,0
1860 DATA .3129,.908,1.414,1.782,1.975,1.975,1.782,1.414,,908,.3129
1870 DATA .93,1.49,2.19,.48,1.01,1.85,.24,.67,1.55,.12,.44,1.3,.06,.29,1.08
1880 DATA .029,.19,.89,.014,.12,.74,.0069,.077,.61,.0035,.05,.5
.49,2.19,.48,1.01,1.85,.24,.67,1.55