;	This is a still shorter version of the Sojak-Levitt WS-USER 
; patch.  After installing WSFAST there is a patch in my MORPAT area 
; that doesn't allow enough room for the original version.
;
;	First of all, I converted the 8080 code to z80, saving a few
; bytes.  But that wasn't enough.  Then I saw that the check for CP/M
; functions was unnecessary.  If de contains the fcb for WSMSGS or MSOVLY1
; then we can assume we need to change the drive/user.  In any case any
; time wasted will be saved by eliminating the comparisons.  I have left
; them in for those who want them--the z80 version using cpir is faster
; than the original.
;	
;	I have left comments to show the additional changes. 
;
;	This works fine on my Kaypro-10.  NB that another few bytes could 
; be saved by eliminating the drive change; on a hard disk there's plenty
; of room for the OVR files on both A & B drives.  If this doesn't work for
; you, please let me know.
;
;						Eric Gans 11/24/84 	  	  
;						213-828-3908
;
;
;******************************************************************************
;
;	title	'WS-USER -- Patch for Wordstar Overlay Files'
;
;		(New, shorter version, (shrunk it so my other,
;		 printer status patch would fit with this one
;		 in the MORPAT area), added values for WS v3.3)
;
;					 -- Kim Levitt  11/13/84
;
;******************************************************************************
;
;	WS.COM can be made to work with ZCPR/ZCPR2/ZCPR3/etc.	 04/17/84
;
;  You know how irritating the @@@@'s get when you try to open a file in a 
; user area that does not have the *.OVR files present ?????  I had been 
; pipping everything to a given user area to edit and then back again. ARRGH.
; To make a long story short, a few hours with DDT revealed several key areas
; within WS.COM that should interest a true hacker. Seems as how the FCB for
; WSOVLY1.OVR is at 364Dh, WSMSGS.OVR is at 3784h, the only BDOS entry vector
; is at 1823h and finally, the area between 02E0h and 035Bh inclusive is a 
; safe patch area. Well, well well....... A real simple kludge of mushware will
; set a default drive and user area every time WS.COM looks for an *.OVR file
; and then set it back again after the DOS operation. The infernal thing can 
; find the *.OVR files from any drive and user area A dream come true and
; it is really painless......
;
;//////////////////////////////////////////////////////////////////////////////
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;
;		Copyright (c) 1984 .... Oak Brook Design 
;   
;	  		     All rights reserved.
;
;	Permission  is  hereby  granted  to copy and distribute this
;	program  for  any  non-commercial  purpose. Any use of this
;	material  for  commercial  advantage  without  prior written
;	consent of John P Sojak acting on behalf of Oak Brook Design 
;	is prohibited. 
;
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;//////////////////////////////////////////////////////////////////////////////
;
;	You MUST examine your Wordstar under SID or DCON to verify several
;	locations within the memory image.... > denotes a console input
;	(You can use ZSID or DDT also, of course... -- KL)
;
;>	A0>DCON
;
;	--- dcon banner and some other gook ---
;
;>	#F100 5000 00		; clear the ram out
;>	#IWS.COM		; set up for read
;>	#R	
;
;>	#P0000			; set a break at warmboot 
;>	#G100
;
; 	--- you will get the usual WS menu.... Just eXit with 'X'
;
;	01 PASS 0000
;	 -Z-E- A=00 B=1800 D=0006 H=3441 S=3443 P=0000	
;	 ----- A'=00 B'=00 D'0000 H'0000 X=0000 Y=0000 JMP XXXX
;	*XXXX
;
;>	#D3780 3790
;	3780: 00 00 00 00 03 57 53 47 53 20 20 4F 56 52 .....WSMSGS  OVR
;	3790: 00	   \	
;		             there it is... 
;				
;					          here it is..
;>	#D3640 3660				/   
;	3640: 00 00 00 00 00 00 00 00 00 00 00 00 57 53 ..............WS
;	3650: 4F 56 4C 59 31 20 4F 56 52 00 00 00 00 00 OVLY1 OVR.......
;	3660: 00 . 	
;
;
;>	#L1820
;	1820   	INX  	H
;	1821	PUSH 	D	
;	1822	PUSH	H
;	1823	CALL	0005	--- here is the DOS entry @ 1823h  
;	1826	POP	H
;	1827	POP	D
;	1829	XTHL
;	182A	RET
;
;>	#-P		; clear the pass point at warmboot
;>	#G0		; and exit to CCP
;
;	A0>
;
;	Now you can assemble the file, I used Mac. M80 / L80 has a problem with
;	extranious 00 between the two ORGs. Dont use it. 
;
;	Use the same procedure to load WS.COM into memory again but this time,
;	dont set any pass point at 0000. Set up for the read with IWSUSER.HEX
;	and then do a R to overlay the hex file. Exit to the CCP and then
;	
;	A0>SAVE 64 WS-TEST.COM
;	(Note: For 3.3 versions, use 69 usually, could be more if your
;	version has been customized with code in the secondary user
;	patch space PGBMEM.)
;
;	Thats it..... WS  will, or should now, work with all user areas and 
;	drives.
;
;****************************************************************************
;
;	NOTE: WS v3.3 values I found in CP/M-80 version:
;
;		FILE/ADDRESS	FCB ADDR
;		============    ========
;		WSMSGS.OVR	3769H
;		WSOVLY1.OVR	3630H
;		CALL BDOS	1835H
;		PATCH AREA	02CBH	(check for previous patches first)
;
;				-- Kim Levitt
;				   (MBBS HQ RCP/M (213) 653-6398)
;
;****************************************************************************
;
; (Always 0005, this is entry point for BDOS function calls)
;
bdos		equ	0005	;BDOS function caller
;
;==============================================================================
;
; The WSMSGS.OVR fcb address:
;
msgfcb		equ	3769h	;(use 3784h for v3.0)
;
;==============================================================================
;
; The WSOVLY1.OVR fcb address:
;
ovrfcb		equ	3630h	;(use 364Dh for v3.0)
;
;==============================================================================
;
; The original BDOS vector call address:
;
bdosvec		equ	1835h	;(use 1823 for v3.0)
;
;==============================================================================
;
; The user patch space where patch code gets loaded:
;
morpat		equ	02CBh	;(use 02E0 for v3.3)
;
;	(This value is the MORPAT value obtained from WS.COM)
;
moroff		equ	3Eh	;this was my situation - (EG)  Set this
;				 to 0 if you have no patches in MORPAT.
;				(normally zero if virgin WS.COM)
;
;	(This value may have to be adjusted if you have a custom patch
;	already in the MORPAT area. If you have the printer status
;	check routine as listed in WSPAT-33.DQC, for instance, and the
;	patch for that starts at MORPAT then this patch would have to
;	start at MORPAT+11h, so you'd have to set MOROFF equ 11h)
;
;moron		equ	not moroff	;(dummy equate, used for user)
;     \--  I didn't bother with this (EG)
;==============================================================================
;
; Set these to your desired default drive and user for the *.OVR files
;
ovruser		equ	1 	; User area...  0-31
ovrdrv		equ	1	; Drive Spec... A:-> 01, B:-> 02 etc
;
;******************************************************************************
;
;		the patch gets called here
;
;******************************************************************************
;
		org	bdosvec	; remove the existing DOS hook
;
;	intercept the call to DOS before actual entry ... 
;
		call	morpat+moroff
;
;******************************************************************************
;
;		the patch gets loaded here
;
;******************************************************************************
;
		org	morpat+moroff	; patch area is here
;
;	check BDOS function and FCB address
;
		push	bc		; save function code (c)
;		ld 	a,c		; check it
;					;**************************************
;		ld 	hl,cptbl	;*cpir does this faster than cpi-
;		ld 	bc,6		;*To use, just take out the ;;
;		cpir			;*NB I moved passit from its original
;		jr 	z,chkit		;*position to save a jr (EG) 
;******************************************************************************
;*		cpi	15		; open file?			*
;*		jz	chkit						*
;*		cpi	16		; close?		+----+  *
;*		jz	chkit					|8080|  *
;*		cpi	17		; search first?		|code|  *
;*		jz	chkit					+----+  *
;*		cpi	18		; search next?			*
;*		jz	chkit						*
;*		cpi	20		; read next?			*
;*		jz	chkit						*	
;*		cpi	33		; read random?			*
;*		jz	chkit						*
;************************************************************************
;	pass the call on without further hassle, its not for us
;
;cptbl		db	15,16,17,18,20,33     ;Z80 version (EG)
;
;******************************************************************************
;
;	check <de> for the two OVR fcb addresses, set <cy> if not found
;
;
;chkit:	<--This label unnecessary in my version (EG)
;
		ld 	a,.low.msgfcb	 ;fcb for WSMSGS.OVR 
		cp	e
		jr 	nz,nogood
		ld	a,.high.msgfcb 
		cp	d
		jr 	z,good
;		
nogood:		ld 	a,.low.ovrfcb 	;fcb for WSOVLY1.OVR 
		cp	e
		jr 	nz,passit
		ld	a,.high.ovrfcb 
		cp	d
		jr 	z,good		; NB - I moved passit here (EG)
passit:		pop	bc		; restore stack
		jp 	bdos		; and return
;
;	found one of the FCB's... set the user and drive 
;
good:		push	de		; save FCB
;
; No need for
; this operation
; --> (EG)      ex 	de,hl		; put FCB in HL
		ld 	a,ovrdrv	; find the overlays on this drive
;
; Even in 8080, you can have 'stax d' instead of 'mov m,a'
; --> (EG)	ld 	(hl),a
		ld 	(de),a		; (stuff in FCB)
;
		ld 	c,32		; get the current user number
		ld	e,0FFh
		call	bdos
		ld	(user),a		; save it
;
		ld 	c,32		
		ld	e,ovruser	; find the overlays in this user
		call	bdos
;
		pop	de		; original fcb addr
		pop	bc		; original function code
;
		call	bdos		; finally we get there...
;
		push	bc		; save bc
		push	af		; save the result flags for later
;
		ld 	c,32		; set the old user... maybe funnies
		ld 	a,(user)
		ld	e,a
		call	bdos
;
		pop	af	; get error flags
		pop	bc		; restore c
;
		ret			; back to Wordstar
;
user:		db	0ffh	; (non-zero to mark end)
;
		end
;
