/*
%CC1 $1.C -X -e5000
%CLINK $1 DIO -S
%DELETE $1.CRL
*/
/*******************************************************************
*                            CB                                    *
********************************************************************
*                 COPYRIGHT 1983 EUGENE H. MALLORY                 *
*******************************************************************/

#INCLUDE <bdscio.h>
#INCLUDE <dio.h>

#define flush /**/
#define AND &&
#define OR ||
#define EQUAL ==
#define NOTEQUAL !=
#define NOT !

#define LOOPTYPE 1
#define IFTYPE 2
FUNCTION CHAR *do_comment();
FUNCTION CHAR *do_begin();
FUNCTION CHAR *do_end();
FUNCTION CHAR *do_case();
FUNCTION CHAR *do_default();
FUNCTION CHAR *do_semi();
FUNCTION CHAR *do_paren();
FUNCTION CHAR *do_quote();
FUNCTION CHAR *do_string();
FUNCTION CHAR *do_next_word();
FUNCTION CHAR inline[MAXLINE];
INT indent,nlflag,step;
INT verb, verbx, verbstk[20];

MAIN(argc,argv)
CHAR **argv;
INT argc;

  BEGIN
    CHAR c;
    INT ii,jj,optionerr;
    CHAR *ss;
    CHAR *stgptr;
    dioinit(&argc,argv);

/*********************************************************************
*                  ARGUMENT PROCESSING                               *
*********************************************************************/

    step = 2;
    optionerr = FALSE;
    FOR (ii=argc-1;ii>0;ii--)
    IF (argv[ii][0] == '-')
      THEN
	FOR (ss = &argv[ii][1]; *ss != '\0';)
	  LOOP
	    SWITCH (toupper(*ss++))
	      BEGIN
	      CASE 'I':
		step = atoi(ss);
		BREAK;
	      CASE 'H':
		optionerr = TRUE;
		BREAK;
	      DEFAULT:
		fprintf(STDERR,"CB: Illegal option %c.\n",*--ss);
		ss++;
		optionerr = TRUE;
		BREAK;
	      END
	    WHILE (isdigit(*ss)) 
	      LOOP
		ss++;
	      ENDLOOP
	  ENDLOOP
	FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
	argc--;
      ENDIF

    IF (optionerr) 
      THEN
	fprintf(STDERR,"CB: -In  n is indent step, default is 2\n");
	exit(0);
      ENDIF
/********************************************************************
*                     END OF ARGUMENT PROCESSING                    *
********************************************************************/

    indent = 0;  	/* start indent at 0 */
    nlflag = 0;  	/* set to bol */
    verbx = 0;  	/* set verb stack empty */
    WHILE (!getstring(inline))
      LOOP
	stgptr = inline;
	WHILE (*stgptr EQUAL ' ' OR *stgptr EQUAL '\t') 
	  LOOP
	    stgptr++;
	  ENDLOOP

	IF (*stgptr EQUAL '\n') 
	  THEN
	    nlflag = -1;
	  ENDIF


	IF (is_begin(stgptr)) ;
	ELSE IF (is_loop(stgptr)) verb = LOOPTYPE;
	ELSE IF (is_if(stgptr)) verb = IFTYPE;
	ELSE verb = 0;
	WHILE (*stgptr NOTEQUAL '\n')
	  LOOP
	    IF (*stgptr EQUAL ';') stgptr = do_semi(stgptr);
	    ELSE IF (is_comment(stgptr)) stgptr = do_comment(stgptr);
	    ELSE IF (is_begin(stgptr)) stgptr = do_begin(stgptr);
	    ELSE IF (is_default(stgptr)) stgptr = do_default(stgptr);
	    ELSE IF (is_case(stgptr)) stgptr = do_case(stgptr);
	    ELSE IF (is_end(stgptr)) stgptr = do_end(stgptr);
	    ELSE IF (is_paren(stgptr)) stgptr = do_paren(stgptr);
	    ELSE IF (is_quote(stgptr)) stgptr = do_quote(stgptr);
	    ELSE IF (is_string(stgptr)) stgptr = do_string(stgptr);
	    ELSE stgptr = do_next_word(stgptr);
	  ENDLOOP
	newline();
      ENDLOOP
    IF (verbx NOTEQUAL 0) error("CB: Too few ENDs.");
    dioflush();
  END

FUNCTION is_comment(string)
CHAR string[];
  BEGIN
    IF ((string[0] EQUAL '/') AND (string[1] EQUAL '*')) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_quote(string)
CHAR string[];
  BEGIN
    IF (string[0] EQUAL '\'') RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_paren(string)
CHAR string[];
  BEGIN
    IF (string[0] EQUAL '(') RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_string(string)
CHAR string[];
  BEGIN
    IF (string[0] EQUAL '"') RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_begin(string)
CHAR string[];
  BEGIN
    IF (string[0] EQUAL '{') RETURN TRUE;
    IF (strmatch(string,"BEGIN")) RETURN TRUE;
    IF (strmatch(string,"LOOP")) RETURN TRUE;
    IF (strmatch(string,"THEN")) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_end(string)
CHAR string[];
  BEGIN
    IF (string[0] EQUAL '}') RETURN TRUE;
    IF (strmatch(string,"ENDLOOP")) RETURN TRUE;
    IF (strmatch(string,"ENDIF")) RETURN TRUE;
    IF (strmatch(string,"END")) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_case(string)
CHAR string[];
  BEGIN
    IF (strmatch(string,"CASE")) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_default(string)
CHAR string[];
  BEGIN
    IF (strmatch(string,"DEFAULT:")) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_if(string)
CHAR string[];
  BEGIN
    IF (strmatch(string,"IF")) RETURN TRUE;
    IF (strmatch(string,"ELSE")) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION is_loop(string)
CHAR string[];
  BEGIN
    IF (strmatch(string,"WHILE")) RETURN TRUE;
    IF (strmatch(string,"DO")) RETURN TRUE;
    IF (strmatch(string,"FOR")) RETURN TRUE;
    RETURN FALSE;
  END

FUNCTION pushv()
  BEGIN
    verbstk[verbx++] = verb;
  END

FUNCTION pullv()
  BEGIN
    verb = verbstk[--verbx];
    IF (verbx < 0) error("CB: Too many ENDs.");
    RETURN verb;
  END


FUNCTION strmatch(s1,s2)
CHAR *s1, *s2;
  BEGIN
    WHILE (*s2) 
      LOOP
	IF (toupper(*s1++) NOTEQUAL *s2++) 
	  THEN
	    RETURN FALSE;
	  ENDIF
      ENDLOOP
    IF (isalpha(*s1)) RETURN FALSE;
    IF (isdigit(*s1)) RETURN FALSE;
    IF (*s1 EQUAL '_') RETURN FALSE;
    IF (*s1 EQUAL ':') RETURN FALSE;
    IF (*s1 EQUAL ';') RETURN FALSE;
    RETURN TRUE;
  END

FUNCTION newline()
  BEGIN
    IF (nlflag < 0)
      THEN
	putchar('\n');
	nlflag = 0;
      ENDIF
  END

FUNCTION CHAR *do_comment(string)
CHAR *string;
  BEGIN
    IF (string NOTEQUAL inline) tabin();
    putchar(*string++);
    putchar(*string++);
    nlflag = -1;
    WHILE (TRUE)
      LOOP
	IF (*string EQUAL '\n') 
	  THEN
            IF (getstring(inline))
	      THEN
		error("CB: EOF encountered in comment.");
	      ENDIF
	    putchar('\n');
	    string = inline;
	    CONTINUE;
	  ENDIF
	IF (*string NOTEQUAL '*') 
	  THEN
	    IF (is_comment(string)) 
	      THEN
		string = do_comment(string);
	      ENDIF
	    ELSE 
	      THEN
		putchar(*string++);
	      ENDIF
	    CONTINUE;
	  ENDIF
	ELSE 
	  THEN
	    IF (string[1] EQUAL '/') /* comment end */
	      THEN
		putchar(*string++);
		putchar(*string++);
		RETURN string;
	      ENDIF
	    ELSE 
	    putchar(*string++);
	  ENDIF
      ENDLOOP
  END

FUNCTION CHAR *do_string(string)
CHAR *string;
  BEGIN
    tabin();
    nlflag = -1;
    putchar(*string++);
    WHILE (*string NOTEQUAL '"')
      LOOP
	putchar(*string);
	IF (*string EQUAL '\n') error("CB: Double quote unmatched at EOL.");
	IF (*string++ EQUAL '\\')
	putchar(*string++);
      ENDLOOP
    putchar(*string++);
    RETURN string;
  END

FUNCTION CHAR *do_quote(string)
CHAR *string;
  BEGIN
    tabin();
    nlflag = -1;
    putchar(*string++);
    WHILE (*string NOTEQUAL '\'') 
      LOOP
	putchar(*string);
	IF (*string EQUAL '\n') error("CB: Single quote unmatched at EOL.");
	IF (*string++ EQUAL '\\') putchar(*string++);
      ENDLOOP
    putchar(*string++);
    RETURN string;
  END

FUNCTION CHAR *do_paren(string)
CHAR *string;
  BEGIN
    int isave;
    indent += step;
    tabin();
    nlflag = -1;
    putchar(*string++);
    WHILE (*string NOTEQUAL ')') 
      LOOP
	IF (*string EQUAL '\n') 
	  THEN
            IF (getstring(inline))
	      THEN
		error("CB: EOF encountered in parens.");
	      ENDIF
	    nlflag = -1;
	    newline();
	    tabin();
	    nlflag = -1;
	    string = inline;
	    WHILE (*string EQUAL ' ' OR *string EQUAL '\t') 
	      LOOP
		string++;
	      ENDLOOP
	    CONTINUE;
	  ENDIF
	IF (*string EQUAL '(') string = do_paren(string);
	ELSE IF (*string EQUAL '\'') string = do_quote(string);
	ELSE IF (*string EQUAL '"') string = do_string(string);
	ELSE putchar(*string++);
      ENDLOOP
    putchar(*string++);
    indent -= step;
    RETURN string;
  END

FUNCTION CHAR *do_begin(string)
CHAR *string;
  BEGIN
    pushv();
    indent += step;
    newline();
    tabin();
    nlflag = -1;
    flush
    IF (strmatch(string,"BEGIN")) 
      THEN
	IF (verb EQUAL LOOPTYPE) printf("LOOP");
	ELSE IF (verb EQUAL IFTYPE) printf("THEN");
	ELSE printf("BEGIN");
	string+=5;
      ENDIF
    IF (strmatch(string,"THEN")) 
      THEN
	printf("THEN");
	string+=4;
      ENDIF
    IF (strmatch(string,"LOOP")) 
      THEN
	printf("LOOP");
	string+=4;
      ENDIF
    IF (*string EQUAL '{') 
      THEN
	IF (verb EQUAL LOOPTYPE) printf("LOOP");
	ELSE IF (verb EQUAL IFTYPE) printf("THEN");
	ELSE printf("BEGIN");
	string+=1;
      ENDIF
    indent += step;
    newline();
    WHILE (*string EQUAL ' ' OR *string EQUAL '\t') 
      LOOP
	string++;
      ENDLOOP
    RETURN string;
  END

FUNCTION CHAR *do_end(string)
CHAR *string;
  BEGIN
    pullv();
    indent -= step;
    newline();
    tabin();
    nlflag = -1;
    flush
    IF (strmatch(string,"ENDIF")) 
      THEN
	printf("ENDIF");
	string+=5;
      ENDIF
    IF (strmatch(string,"ENDLOOP")) 
      THEN
	printf("ENDLOOP");
	string+=7;
      ENDIF
    IF (strmatch(string,"END")) 
      THEN
	IF (verb EQUAL LOOPTYPE) printf("ENDLOOP");
	ELSE IF (verb EQUAL IFTYPE) printf("ENDIF");
	ELSE printf("END");
	string+=3;
      ENDIF
    IF (*string EQUAL '}') 
      THEN
	IF (verb EQUAL LOOPTYPE) printf("ENDLOOP");
	ELSE IF (verb EQUAL IFTYPE) printf("ENDIF");
	ELSE printf("END");
	string+=1;
      ENDIF
    indent -= step;
    newline();
    WHILE (*string EQUAL ' ' OR *string EQUAL '\t') 
      LOOP
	string++;
      ENDLOOP
    RETURN string;
  END

FUNCTION CHAR *do_case(string)
CHAR *string;
  BEGIN
    indent -= step;
    newline();
    tabin();
    nlflag = -1;
    flush
    printf("CASE");
    string += 4;
    indent += step;
    RETURN string;
  END

FUNCTION CHAR *do_default(string)
CHAR *string;
  BEGIN
    indent -= step;
    newline();
    tabin();
    nlflag = -1;
    flush
    printf("DEFAULT:");
    string+=8;
    indent += step;
    RETURN string;
  END

FUNCTION CHAR *do_semi(string)
CHAR *string;
  BEGIN
    tabin();
    nlflag = -1;
    putchar(*string++);
    WHILE (*string EQUAL ' ' OR *string EQUAL '\t') 
      LOOP
	string++;
      ENDLOOP
    IF (is_begin(string)) error("CB: BEGIN follows ;.");
    ELSE IF (is_loop(string)) verb = LOOPTYPE;
    ELSE IF (is_if(string)) verb = IFTYPE;
    ELSE verb = 0;
    IF (*string NOTEQUAL '\n' AND NOT is_comment(string))
      THEN
	newline();
      ENDIF
    IF (is_comment(string)) 
      THEN
	putchar(' ');
	putchar(' ');
	putchar('\t');
      ENDIF
    RETURN string;
  END

FUNCTION CHAR *do_next_word(string)
CHAR *string;
  BEGIN
    tabin();
    nlflag = -1;
    WHILE (TRUE)
      LOOP
	IF (*string EQUAL '\n') RETURN string;
	IF (*string EQUAL ' ' OR *string EQUAL '\t') BREAK;
	IF (*string EQUAL ';') RETURN string;
	IF (*string EQUAL '}') RETURN string;
	IF (*string EQUAL '{') RETURN string;
	IF (*string EQUAL '\'') RETURN string;
	IF (*string EQUAL '"') RETURN string;
	IF (*string EQUAL '(') RETURN string;
	IF (is_comment(string)) RETURN string;
	putchar(*string++);
      ENDLOOP
    putchar(' ');
    WHILE (*string EQUAL ' ' OR *string EQUAL '\t') 
      LOOP
	string++;
      ENDLOOP
    RETURN string;
  END

FUNCTION tabin()
  BEGIN
    IF (nlflag >= 0) 
      THEN
	WHILE (nlflag+8 <= indent)
	  LOOP
	    putchar('\t');
	    nlflag+=8;
	  ENDLOOP
	WHILE (nlflag++ < indent) 
	  LOOP
	    putchar(' ');
	  ENDLOOP
      ENDIF
  END
