/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO  -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                               SUM                                  *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/

#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

#DEFINE NDIGITS 20
#DEFINE LONG 22


MAIN(argc,argv)

CHAR **argv;
INT argc;

BEGIN  
    INT  c,i,j;
    CHAR sum[LONG],number[LONG],nstring[LONG];
    INT col,field;
    CHAR string[MAXLINE];
    dioinit(&argc,argv);

/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/

INT ii,jj,optionerr;
CHAR *ss;
	optionerr = 0;
	col = field = 1;
	
	FOR (ii=argc-1;ii>0;ii--)
	    IF (argv[ii][0] == '-')
		BEGIN
		    FOR (ss = &argv[ii][1]; *ss != '\0';)
			BEGIN
			    SWITCH (toupper(*ss++))
				BEGIN
				    CASE 'F':
					field = atoi(ss);
					BREAK;
				    CASE 'C':
					col= atoi(ss);
					BREAK;
				    CASE 'H':
					optionerr = TRUE;
					BREAK;
				    DEFAULT:
					typef("SUM: Illegal option %c.\n"
						,*--ss);
					ss++;
					optionerr = TRUE;
					BREAK;
				END
			    WHILE (isdigit(*ss)) ss++;
			END
		    FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
		    argc--;
		END
	
	
	IF (optionerr) 
	    BEGIN
		typef("SUM:   Legal options are:\n");
		typef("-Fn    Field to sum.\n");
		typef("-Cn    Column to begin search.\n");
		exit(0);
	    END
	    
/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/
	    
    atol(sum,"0");
    WHILE (!getstring(string))
	BEGIN
	    i = col-1;
	    j = field-1;
	    IF (i < strlen(string));
		WHILE (string[i]) 
		    BEGIN
			IF (isdigit(string[i]) || string[i] == '-')
			    BEGIN
				IF (!j--)
				    BEGIN
					atol(number,&string[i]);
					ladd(sum,number,sum);
					BREAK;
				    END
				ELSE
				    WHILE (isdigit(string[++i])) ;
			    END
			i++;
		    END
	END
    printf("%s\n",ltoa(nstring,sum));
    dioflush();
END  

CHAR  *ladd(sum,a1,a2)
CHAR sum[],a1[],a2[];
    BEGIN
	IF (a1[0] == '-'  && a2[0] == '-')
	    BEGIN
		sum[0] = '-';
		IF (lsum(sum,a1,a2))
		    error("LONG ADD: Overflow.");
		return sum;
	    END
	ELSE IF (a1[0] == '+'  && a2[0] == '+')
	    BEGIN
		sum[0] = '+';
		IF (lsum(sum,a1,a2))
		    error("LONG ADD: Overflow.");
		return sum;
	    END
	ELSE IF (a1[0] == '+'  && a2[0] == '-')
	    BEGIN
		sum[0] = '+';
		IF (ldif(sum,a1,a2))
		    sum[0] = '-';
		return sum;
	    END
	ELSE IF (a1[0] == '-'  && a2[0] == '+')
	    BEGIN
		sum[0] = '+';
		IF (ldif(sum,a2,a1))
		    sum[0] = '-';
		return sum;
	    END
	ELSE
	    error("LONG ADD: Bad sign character.");
	    
END

CHAR  *lsub(sum,a1,a2)
CHAR sum[],a1[],a2[];
    BEGIN
	IF (a1[0] == '+'  && a2[0] == '-')
	    BEGIN
		sum[0] = '+';
		IF (lsum(sum,a1,a2))
		    error("LONG ADD: Overflow.");
		return sum;
	    END
	ELSE IF (a1[0] == '-'  && a2[0] == '+')
	    BEGIN
		sum[0] = '-';
		IF (lsum(sum,a1,a2))
		    error("LONG ADD: Overflow.");
		return sum;
	    END
	ELSE IF (a1[0] == '+'  && a2[0] == '+')
	    BEGIN
		sum[0] = '+';
		IF (ldif(sum,a1,a2))
		    sum[0] = '-';
		return sum;
	    END
	ELSE IF (a1[0] == '-'  && a2[0] == '-')
	    BEGIN
		sum[0] = '-';
		IF (ldif(sum,a2,a1))
		    sum[0] = '+';
		return sum;
	    END
	ELSE
	    error("LONG ADD: Bad sign character.");
	    
END

lsum(sum,a1,a2)
CHAR sum[],a1[],a2[];
    BEGIN
    INT i,carry;
	carry = 0;
	FOR (i = NDIGITS;i>=1;i--)
	    BEGIN
		sum[i] = a1[i] + a2[i] + carry;
		IF (sum[i] > 9)
		    BEGIN
			carry = 1;
			sum[i] -= 10;
		    END
		ELSE
		    carry = 0;
	    END
	return carry;
    END
    
    
ldif(dif,a1,a2)
CHAR dif[],a1[],a2[];
    BEGIN
    INT i,temp,borrow;
    CHAR tlong[LONG];
	borrow = 0;
	FOR (i = NDIGITS;i>=1;i--)
	    BEGIN
		temp = a1[i] - a2[i] - borrow;
		IF (temp < 0) 
		    BEGIN
			borrow = 1;
			temp += 10;
		    END
		ELSE
		    borrow = 0;
		dif[i] = temp;
	    END
	IF (borrow)
	    BEGIN
		FOR (i = 1;i<=NDIGITS;i++)
		    dif[i] = 9-dif[i];
		lsum(dif,dif,atol(tlong,"1"));
	    END
	return borrow;
    END
    
    CHAR *atol(long,string)
    CHAR long[],string[];
	BEGIN
	    INT i,j,k;
	    long[0] = '+';
	    FOR (i = 1; i<=NDIGITS; i++) long[i] = 0;
	    i = 0;
	    WHILE (!isdigit(string[i])
		    && string[i] != '+'
		    && string[i] != '-'
		    && string[i] != 0) i++;
	    IF (string[i] == 0) return long;
	    IF (string[i] == '+' || string[i] == '-')
		long[0] = string[i++];
	    
	    j = i;
	    WHILE (isdigit(string[j])) j++;
	    IF ((j-i) > NDIGITS)
		error("ATOL: Number too long.");
	    FOR (k=NDIGITS-j+i+1;k<=NDIGITS+1;k++)
		long[k] = string[i++] - '0';
	    return long;
	END
	
CHAR *ltoa(string,long)
CHAR string[],long[];
    BEGIN
	INT flag,i,j;
	string[0] = long[0];
	j = flag = 1;
	IF (string[0] == '+') j = 0;
	FOR (i=1;i<=NDIGITS;i++)
	    BEGIN
		IF (long[i] == 0 && flag && i != NDIGITS) CONTINUE;
		flag = 0;
		string[j++] = long[i] + '0';
	    END
	string[j] = 0;
	return string;
    END
